#import "ReaderViewController.h"
#import "uniMag.h"

@interface ReaderViewController() <UIActionSheetDelegate>
@end

@implementation ReaderViewController
@synthesize umVc=_umVc;
@synthesize lbReaderType = _lbReaderType;

extern UmReader g_readerType;

//-----------------------------------------------------------------------------
#pragma mark - life cycle -
//-----------------------------------------------------------------------------
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

/*
- (void)dealloc {
    [_lbReaderType release];
    [super dealloc];
}
*/

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    
    [self refreshReaderTypeLabel];
}

- (void)refreshReaderTypeLabel {
    g_readerType = self.umVc.uniReader.readerType;
    self.lbReaderType.text = UmReader_lookup(g_readerType);
}

//-----------------------------------------------------------------------------
#pragma mark - select reader type UIActionSheet -
//-----------------------------------------------------------------------------
static const UmReader UmReaderTable[] = {
//    UMREADER_UNIMAG_ORIGINAL, //not showing the legacy UniMag (original)
    UMREADER_UNIMAG_PRO,
    UMREADER_UNIMAG_II,
    UMREADER_SHUTTLE,
};
static const int UmReaderTableLen = sizeof(UmReaderTable)/sizeof(UmReader);


- (void) DealwithReaderTypeIndex: (NSInteger)Index {
    //ignore cancel button
    if (Index == UmReaderTableLen)
        return;
    
    UmReader readerType = UmReaderTable[Index];
    self.umVc.uniReader.readerType = readerType;
    [self refreshReaderTypeLabel];
}

- (IBAction)selectReaderType:(id)sender {
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"Select reader type" message:nil preferredStyle:UIAlertControllerStyleActionSheet];

    // Add AlertAction call back
    for (int i=0; i<UmReaderTableLen; i++){
        UIAlertAction *tpAction = [UIAlertAction actionWithTitle: UmReader_lookup(UmReaderTable[i]) style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            [self DealwithReaderTypeIndex: i];
        }];
        [alertController addAction:tpAction];
    }

    
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        NSLog(@"Canel selection.");
    }];
    [alertController addAction:cancelAction];
   
    //Shawn Li, 2019-10-8, deal with the iPad crash
    NSString *deviceType = [UIDevice currentDevice].model;
    if([deviceType isEqualToString:@"iPad"]) {
        NSLog(@"Is iPad.");
        UIPopoverPresentationController *pop = [alertController popoverPresentationController];
        pop.sourceView = self.umVc.view;
        pop.permittedArrowDirections = UIPopoverArrowDirectionRight;
        CGRect rect1 = self.umVc.accessibilityFrame;
        
        UIWindow * w = [UIApplication sharedApplication].keyWindow;
        int kScreenWidth1 = w.bounds.size.width;
        int kScreenHeight1 = w.bounds.size.height;
        NSLog(@"kheight: %d kwidth: %d;", kScreenWidth1, kScreenHeight1);
        rect1.origin.x += kScreenWidth1 - 50;
        rect1.origin.y += kScreenHeight1 - 200;
        NSLog(@"height: %lf; width: %lf;", rect1.origin.x, rect1.origin.y);
        pop.sourceRect = rect1;
    }
    
    [self presentViewController:alertController animated:true completion:nil];
    
}

@end
